/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma2d.h"
#include "ltdc.h"
#include "rng.h"
#include "spi.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"
#include "fmc.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "BSP_LCD.h"
#include "TouchPanel.h"
#include "Hangle.h"
#include "English.h"
#include <stdio.h>

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
uint32_t i, k;
__IO uint16_t* SDRAM_PAGE_0 = (__IO uint16_t*)0xC0000000;
__IO uint16_t* SDRAM_PAGE_1 = (__IO uint16_t*)0xC0100000;
__IO uint16_t*  SDRAM;

uint8_t fTouch = 0;
uint16_t	TouchX, TouchY;
char str[30];
int Count, oldCount;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

// Systick 콜백함수입니다.
void HAL_SYSTICK_Callback(void)
{
	static int cnt = 0;

	cnt++;
	if(cnt > 500)
	{
		cnt = 0;
		HAL_GPIO_TogglePin(LED_GPIO_Port, LED_Pin);

//		Count++;
	}
}

// LED 터치판넬이 눌렸을 때
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if(GPIO_Pin == GPIO_PIN_3) fTouch = 1;
	if(GPIO_Pin == GPIO_PIN_2) Count++;
}


void Demo_Color(void)
{
	LCD_Clear(RED);
	HAL_Delay(1000);
	LCD_Clear(GREEN);
	HAL_Delay(1000);
	LCD_Clear(BLUE);
	HAL_Delay(1000);
}

void Demo_Line(void)
{
	uint16_t i, x1, y1, x2, y2, color, w, h;
	uint32_t rn;

	w = LCD_GetXSize();
	h = LCD_GetYSize();

	LCD_Clear(WHITE);

	for(i = 0; i < 5000; i++)
	{
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		x1 = rn % w;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		x2 = rn % w;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		y1 = rn % h;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		y2 = rn % h;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		color = rn % 0x10000;

		LCD_DrawLine(x1, y1, x2, y2, color);
	}
}

void Demo_Circle(void)
{
	uint16_t i, x, y, r, color, w, h;
	uint32_t rn;

	w = LCD_GetXSize();
	h = LCD_GetYSize();

	LCD_Clear(WHITE);

	for(i = 0; i < 5000; i++)
	{
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		x = rn % w;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		y = rn % h;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		r = rn % 100;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		color = rn % 0x10000;

		LCD_DrawCircle(x, y, r, color);
	}
}

void Demo_FillRec(void)
{
	uint16_t i, x1, y1, x2, y2, color, w, h;
	uint32_t rn;

	w = LCD_GetXSize();
	h = LCD_GetYSize();

	LCD_Clear(WHITE);

	for(i = 0; i < 500; i++)
	{
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		x1 = rn % w;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		x2 = rn % w;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		y1 = rn % h;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		y2 = rn % h;
		HAL_RNG_GenerateRandomNumber(&hrng, &rn);
		color = rn % 0x10000;

		LCD_FillRect(x1, y1, x2, y2, color);
	}
}

void Demo_Text(void)
{
#if 0   // 프레임 버퍼에 직접 써 넣는 방식입니다.
	SDRAM = SDRAM_PAGE_0;
	for(i = 0; i < LCD_GetXSize() * LCD_GetYSize() / 5L; i++) SDRAM[i] = RED;
	for(i = 0; i < LCD_GetXSize() * LCD_GetYSize() / 5L; i++) SDRAM[i + (LCD_GetXSize() * LCD_GetYSize() / 5L) * 1L] = GREEN;
	for(i = 0; i < LCD_GetXSize() * LCD_GetYSize() / 5L; i++) SDRAM[i + (LCD_GetXSize() * LCD_GetYSize() / 5L) * 2L] = BLUE;
	for(i = 0; i < LCD_GetXSize() * LCD_GetYSize() / 5L; i++) SDRAM[i + (LCD_GetXSize() * LCD_GetYSize() / 5L) * 3L] = YELLOW;
	for(i = 0; i < LCD_GetXSize() * LCD_GetYSize() / 5L; i++) SDRAM[i + (LCD_GetXSize() * LCD_GetYSize() / 5L) * 4L] = ORANGE;
#else		// DMA2D 로 그리는 방식입니다. 더 빠릅니다.
	LCD_FillRect(0, (LCD_GetYSize() / 5) * 0, LCD_GetXSize(), LCD_GetYSize() / 5, RED);
	LCD_FillRect(0, (LCD_GetYSize() / 5) * 1, LCD_GetXSize(), LCD_GetYSize() / 5, GREEN);
	LCD_FillRect(0, (LCD_GetYSize() / 5) * 2, LCD_GetXSize(), LCD_GetYSize() / 5, BLUE);
	LCD_FillRect(0, (LCD_GetYSize() / 5) * 3, LCD_GetXSize(), LCD_GetYSize() / 5, YELLOW);
	LCD_FillRect(0, (LCD_GetYSize() / 5) * 4, LCD_GetXSize(), LCD_GetYSize() / 5, ORANGE);
#endif

	LCD_Puts26x48(0, 0,   (uint8_t *)"Hello World.", TFT_STRING_MODE_BACKGROUND);
	LCD_Puts18x32(0, 48,  (uint8_t *)"Hello World.", TFT_STRING_MODE_BACKGROUND);
	LCD_Puts14x24(0, 80,  (uint8_t *)"Hello World.", TFT_STRING_MODE_BACKGROUND);
	LCD_Puts8x16( 0, 104, (uint8_t *)"Hello World.", TFT_STRING_MODE_BACKGROUND);

	LCD_SetTextColor(YELLOW);
	LCD_SetBackgroundColor(MAROON);
	LCD_Puts14x24(0, 120,  (uint8_t *)"Yellow Text.", TFT_STRING_MODE_BACKGROUND);
	LCD_Puts14x24(0, 150,  (uint8_t *)"No Background Text.", TFT_STRING_MODE_NO_BACKGROUND);

	DisplayHangle(0, 180, "한글입니다. ABCDEFG");  // 한글 코드는  UTF-8 을 사용하였습니다.
}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_FMC_Init();
  MX_LTDC_Init();
  MX_USART1_UART_Init();
  MX_SPI4_Init();
  MX_TIM16_Init();
  MX_DMA2D_Init();
  MX_RNG_Init();
  /* USER CODE BEGIN 2 */
  LCD_Init();

  Demo_Color();
  Demo_Line();
	HAL_Delay(500);
  Demo_Circle();
	HAL_Delay(500);
  Demo_FillRec();
	HAL_Delay(500);
  Demo_Text();


  uint32_t Xpos = 300;
  uint32_t Ypos = 200;
  uint32_t Width = 250;
  uint32_t Height = 150;

  uint32_t Address = hltdc.LayerCfg[0].FBStartAdress;
	uint32_t pSrc = Address + 2 * (LCD_GetXSize() * 0 + 0);
	uint32_t pDst = Address + 2 * (LCD_GetXSize() * Ypos + Xpos);

	//  	_DMA2D_Fill(void * pDst, uint32_t xSize, uint32_t ySize, uint32_t OffLine, uint32_t ColorIndex, uint32_t PixelFormat);
		_DMA2D_Fill((void *)pDst, 300, 250, LCD_GetXSize()-300, PINK, DMA2D_OUTPUT_RGB565); // LTDC_PIXEL_FORMAT_RGB565


//  	_DMA2D_Copy(pSrc,  pDst, xSize,  ySize,  OffLineSrc, OffLineDst, PixelFormat);
//		_DMA2D_Copy((void *)pSrc, (void *)pDst, Width, Height, LCD_GetXSize()-Width, LCD_GetXSize()-Width, LTDC_PIXEL_FORMAT_RGB565);
		_DMA2D_Copy((void *)pSrc, (void *)pDst, Width, Height, LCD_GetXSize()-Width, LCD_GetXSize()-Width, LTDC_PIXEL_FORMAT_RGB565);



	/* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
  	if(fTouch)
  	{
  		fTouch = 0;
  		HAL_NVIC_DisableIRQ(EXTI3_IRQn);

  		if(GetTouchPannel(&TouchX, &TouchY))
  		{
  			sprintf(str, "X:%5d Y:%5d", TouchX, TouchY);
  			DisplayHangle(600, 10, str);
  		}

  		HAL_NVIC_EnableIRQ(EXTI3_IRQn);
  	}

  	if(oldCount != Count)
  	{
  		oldCount = Count;

			sprintf(str, "CNT:%5d", Count);
			DisplayHangle(600, 30, str);
  	}


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Supply configuration update enable
  */
  HAL_PWREx_ConfigSupply(PWR_LDO_SUPPLY);
  /** Configure the main internal regulator output voltage
  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE0);

  while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}
  /** Macro to configure the PLL clock source
  */
  __HAL_RCC_PLL_PLLSOURCE_CONFIG(RCC_PLLSOURCE_HSE);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI48|RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSI48State = RCC_HSI48_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 2;
  RCC_OscInitStruct.PLL.PLLN = 44;
  RCC_OscInitStruct.PLL.PLLP = 1;
  RCC_OscInitStruct.PLL.PLLQ = 5;
  RCC_OscInitStruct.PLL.PLLR = 2;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_3;
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
  RCC_OscInitStruct.PLL.PLLFRACN = 0;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_D3PCLK1|RCC_CLOCKTYPE_D1PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV2;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV2;
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
